(function e(t,n,r){function s(o,u){if(!n[o]){if(!t[o]){var a=typeof require=="function"&&require;if(!u&&a)return a(o,!0);if(i)return i(o,!0);var f=new Error("Cannot find module '"+o+"'");throw f.code="MODULE_NOT_FOUND",f}var l=n[o]={exports:{}};t[o][0].call(l.exports,function(e){var n=t[o][1][e];return s(n?n:e)},l,l.exports,e,t,n,r)}return n[o].exports}var i=typeof require=="function"&&require;for(var o=0;o<r.length;o++)s(r[o]);return s})({1:[function(require,module,exports){
"use strict";

var _wobserver = require("./wobserver");

var host = window.location.host + window.location.pathname;
if (host.endsWith("/")) {
  host = host.substr(0, host.length - 1);
}

var wobserver = new _wobserver.Wobserver(host);

},{"./wobserver":8}],2:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
function process_to_node(process) {
  return {
    HTMLclass: process.meta.class,
    text: {
      name: process.name,
      title: process.pid
    },
    meta: {
      process: process
    },
    children: process.children.map(process_to_node)
  };
}

var ApplicationGraph = {
  show: function show(application, graph_id) {
    var structure = process_to_node(application);

    var tree_structure = {
      chart: {
        container: "#" + graph_id,
        rootOrientation: "WEST",
        levelSeparation: 30,
        siblingSeparation: 15,
        subTeeSeparation: 25,

        node: {
          HTMLclass: 'process-node',
          drawLineThrough: false
        },
        connectors: {
          type: "straight",
          style: {
            "stroke-width": 2,
            "stroke": "#ccc"
          }
        }
      },

      nodeStructure: structure
    };

    new Treant(tree_structure);
  }
};

exports.ApplicationGraph = ApplicationGraph;

},{}],3:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var chart_steps = 100;

function format_timestamp(timestamp) {
  var lastTimestamp = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  if (Math.floor(lastTimestamp / 5) == Math.floor(timestamp / 5)) {
    return '       ';
  }
  lastTimestamp = timestamp;

  var date = new Date(timestamp * 1000);

  var minutes = date.getMinutes();
  if (minutes < 10) {
    minutes = '0' + minutes;
  }

  var seconds = date.getSeconds();
  if (seconds < 10) {
    seconds = '0' + seconds;
  }

  return date.getHours() + ':' + minutes + ':' + seconds;
}

function generate_data_sets(data) {
  return data.map(function (item) {
    var color = 'rgba(' + item.r + ', ' + item.g + ', ' + item.b;

    return {
      label: item.label,
      type: 'line',
      fillColor: color + ', 0.1)',
      strokeColor: color + ', 0.8)',
      pointColor: color + ', 0)',
      pointStrokeColor: color + ', 0)',
      multiTooltipTemplate: item.label + ' - <%= value %>',
      data: Array(chart_steps).fill(0)
    };
  });
}

function generate_chart(id, data, unit, chartOwner) {
  var container = document.getElementById(id);
  container.className = 'wobserver-chart';
  var canvas = document.createElement('canvas');

  container.appendChild(canvas);

  var ctx = canvas.getContext('2d');

  var starting_data = {
    labels: Array(chart_steps).fill(''),
    datasets: generate_data_sets(data)
  };

  var options = {
    responsive: true,
    maintainAspectRatio: false,
    animationSteps: 1,
    scaleLabel: "<%=value%> " + unit,
    multiTooltipTemplate: "<%=value%> " + unit,
    scales: {
      xAxes: [{
        type: 'time',
        time: {
          displayFormats: {
            'millisecond': 'MMM DD',
            'second': 'MMM DD',
            'minute': 'MMM DD',
            'hour': 'MMM DD',
            'day': 'MMM DD',
            'week': 'MMM DD',
            'month': 'MMM DD',
            'quarter': 'MMM DD',
            'year': 'MMM DD'
          }
        }
      }]
    },
    legendTemplate: '<ul>' + '<% for (var i=0; i<datasets.length; i++) { %>' + '<li>' + '<span style=\"background-color:<%= datasets[i].strokeColor %>\"></span>' + '<% if (datasets[i].label) { %><%= datasets[i].label %><% } %>' + '</li>' + '<% } %>' + '</ul>'
  };

  var chart = new Chart(ctx).Line(starting_data, options);

  var legend_div = document.createElement('div');
  legend_div.className = 'chart-legend';
  legend_div.innerHTML = chart.generateLegend();
  container.append(legend_div);

  container.chart = chartOwner;

  return chart;
}

var WobserverChart = function () {
  function WobserverChart(id, data, unit) {
    _classCallCheck(this, WobserverChart);

    this.chart = generate_chart(id, data, unit, this);
    this.last_timestamp = '';
  }

  _createClass(WobserverChart, [{
    key: 'update',
    value: function update(data) {
      this.chart.addData(data, format_timestamp(data.timestamp, this.last_timestamp));
      this.chart.removeData();
      this.last_timestamp = data.timestamp;
    }
  }]);

  return WobserverChart;
}();

exports.WobserverChart = WobserverChart;

},{}],4:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.NodeDialog = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _popup = require('./popup.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var NodeDialog = function () {
  function NodeDialog(wobserver) {
    _classCallCheck(this, NodeDialog);

    this.wobserver = wobserver;
  }

  _createClass(NodeDialog, [{
    key: 'show',
    value: function show() {
      var _this = this;

      this.wobserver.client.command_promise('nodes').then(function (e) {
        var nodes = e.data;

        _popup.Popup.show('\n      <div id="node_selection">\n        <span>Select node:</span>\n        <ul id="node_options">\n        </ul>\n      </div>\n      ');

        var node_options = document.getElementById('node_options');

        nodes.forEach(function (node) {
          var li = document.createElement('li');
          var selected = _this.wobserver.client.node == node.name;

          li.className = selected ? 'node selected' : 'node';

          var local_class = node['local?'] ? ' (local)' : '';

          li.innerHTML = '<span>' + node.name + local_class + '</span><detail>' + node.host + ':' + node.port + '</detail>';

          if (selected) {
            li.addEventListener('click', function () {
              return is.hide();
            });
          } else {
            li.addEventListener('click', function () {
              _this.wobserver.client.set_node(node.name);
              _this.hide();
            });
          }

          node_options.appendChild(li);
        });
      });
    }
  }, {
    key: 'hide',
    value: function hide() {
      _popup.Popup.hide();
    }
  }]);

  return NodeDialog;
}();

exports.NodeDialog = NodeDialog;

},{"./popup.js":5}],5:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
var popup = null;

function getPopup() {
  if (popup) {
    return popup;
  }

  popup = document.createElement('div');

  popup.id = 'popup-overlay';
  popup.style.display = 'none';

  popup.addEventListener('click', function (e) {
    if (e.target.id == 'popup-overlay') {
      Popup.hide();
    }
  });

  document.body.appendChild(popup);

  return popup;
}

var Popup = {
  show: function show(content) {
    var popup = getPopup();

    popup.innerHTML = content;

    popup.style.display = 'block';
  },
  hide: function hide() {
    getPopup().style.display = 'none';
  }
};

exports.Popup = Popup;

},{}],6:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.ProcessDetail = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _popup = require('./popup.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function format_pid_url(pid) {
  if (pid.startsWith('#Port')) {
    return pid;
  }

  return '<li><a href="javascript:window.show_process(\'' + pid + '\')">' + pid + '</a></li>';
}

var ProcessDetail = function () {
  function ProcessDetail(process, wobserver) {
    _classCallCheck(this, ProcessDetail);

    this.process = process;
    this.wobserver = wobserver;
  }

  _createClass(ProcessDetail, [{
    key: 'show',
    value: function show() {
      this.wobserver.client.command_promise('process/' + this.process).then(function (e) {
        var process = e.data;
        if (process == 'error') {
          _popup.Popup.show('\n          <div id="process_information">\n            <span>Process information:</span>\n            <p>Process is either dead or protected and therefore can not be shown.</p>\n          </div>\n        ');
          return;
        }
        // <a href="javascript:window.show_process('${process.pid}')">
        var links = process.relations.links.map(function (pid) {
          return format_pid_url(pid);
        }).join('');
        var ancestors = process.relations.ancestors.map(function (pid) {
          return format_pid_url(pid);
        }).join('');
        var monitors = '';

        _popup.Popup.show('\n      <div id="process_information">\n        <span>Process information:</span>\n        <table>\n          <caption>Overview</caption>\n          <tr><th>Process id:</th><td>' + process.pid + '</td></tr>\n          <tr><th>Registered name:</th><td>' + process.registered_name + '</td></tr>\n          <tr><th>Status:</th><td>' + process.meta.status + '</td></tr>\n          <tr><th>Message Queue Length:</th><td>' + process.message_queue_len + '</td></tr>\n          <tr><th>Group Leader:</th><td><a href="javascript:window.show_process(\'' + process.relations.group_leader + '\')">' + process.relations.group_leader + '</a></td></tr>\n        </table>\n        <table>\n          <caption>Memory</caption>\n          <tr><th>Total:</th><td>' + process.memory.total + '</td></tr>\n          <tr><th>Heap Size:</th><td>' + process.memory.heap_size + '</td></tr>\n          <tr><th>Stack Size:</th><td>' + process.memory.stack_size + '</td></tr>\n          <tr><th>GC Min Heap Size:</th><td>' + process.memory.gc_min_heap_size + '</td></tr>\n          <tr><th>GC FullSweep After:</th><td>' + process.memory.gc_full_sweep_after + '</td></tr>\n        </table>\n        <div id="process_relations">\n          <div>\n            <span>Links</span>\n            <ul>\n              ' + links + '\n            </ul>\n          </div>\n          <div>\n            <span>Ancestors</span>\n            <ul>\n              ' + ancestors + '\n            </ul>\n          </div>\n          <div>\n            <span>Monitors</span>\n            <ul>\n              ' + monitors + '\n            </ul>\n          </div>\n        </div>\n        <span>State</span>\n        <pre>' + process.state + '</pre>\n      </div>\n      ');
      });
    }
  }, {
    key: 'hide',
    value: function hide() {
      _popup.Popup.hide();
    }
  }]);

  return ProcessDetail;
}();

exports.ProcessDetail = ProcessDetail;

},{"./popup.js":5}],7:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.TableDetail = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _popup = require('./popup.js');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var TableDetail = function () {
  function TableDetail(table, wobserver) {
    _classCallCheck(this, TableDetail);

    this.table = table;
    this.wobserver = wobserver;
  }

  _createClass(TableDetail, [{
    key: 'show',
    value: function show() {
      this.wobserver.client.command_promise('table/' + this.table).then(function (e) {
        var table = e.data;
        if (table == 'error') {
          _popup.Popup.show('\n        <div id="process_information">\n        Can not show table.\n        </div>\n        ');
          return;
        }

        var table_data = table.data.map(function (row, index) {
          var formatted_row = row.map(function (field) {
            return '<td><pre>' + field + '</pre></td>';
          }).join('');
          return '<tr><th>' + (index + 1) + '</th>' + formatted_row + '</tr>';
        }).join('');

        _popup.Popup.show('\n      <div id="table_information">\n        <span>Table Information:</span>\n        <div>\n          <table>\n            ' + table_data + '\n          </table>\n        </div>\n      </div>\n      ');
      });
    }
  }, {
    key: 'hide',
    value: function hide() {
      _popup.Popup.hide();
    }
  }]);

  return TableDetail;
}();

exports.TableDetail = TableDetail;

},{"./popup.js":5}],8:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.Wobserver = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _wobserver_client = require('./wobserver_client');

var _wobserver_render = require('./wobserver_render');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var Wobserver = function () {
  function Wobserver(host) {
    var _this = this;

    _classCallCheck(this, Wobserver);

    this.host = host;
    this.update_interval = 1000;
    this.refreshTimer = null;

    _wobserver_render.WobserverRender.init(this);

    this.client = new _wobserver_client.WobserverClient(host);
    this.client.connect(function (n) {
      return _wobserver_render.WobserverRender.set_node(n);
    }, function (client) {
      return _this.client = client;
    });

    window.show_process = function (process) {
      return _wobserver_render.WobserverRender.show_process(process, _this);
    };
    window.show_table = function (table) {
      return _wobserver_render.WobserverRender.show_table(table, _this);
    };
  }

  _createClass(Wobserver, [{
    key: 'display',
    value: function display(command, renderer) {
      this.client.command_promise(command).then(function (e) {
        return renderer(e);
      });
    }
  }, {
    key: 'open',
    value: function open(command, refresh, renderer) {
      var _this2 = this;

      clearInterval(this.refreshTimer);
      this.display(command, renderer);

      if (refresh > 0) {
        this.refreshTimer = setInterval(function () {
          return _this2.display(command, renderer);
        }, refresh * this.update_interval);
      }
    }
  }, {
    key: 'close',
    value: function close(command, refresh) {}
  }]);

  return Wobserver;
}();

exports.Wobserver = Wobserver;

},{"./wobserver_client":10,"./wobserver_render":11}],9:[function(require,module,exports){
"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function build_url(host, command) {
  var node = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : "";

  if (node == "local") {
    return 'http://' + host + '/api/' + encodeURI(command).replace(/#/g, '%23');
  } else {
    return 'http://' + host + '/api/' + encodeURI(node) + "/" + encodeURI(command).replace(/#/g, '%23');
  }
}

var WobserverApiFallback = function () {
  function WobserverApiFallback(host) {
    var node = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : "local";

    _classCallCheck(this, WobserverApiFallback);

    this.host = host;
    this.node = node;
  }

  _createClass(WobserverApiFallback, [{
    key: "command",
    value: function command(_command) {
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      console.log('Send fallback command');
    }
  }, {
    key: "command_promise",
    value: function command_promise(command) {
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      return fetch(build_url(this.host, command, this.node)).then(function (res) {
        return res.json();
      }).then(function (data) {
        return {
          data: data,
          timestamp: Date.now() / 1000 | 0,
          type: command
        };
      }).catch(function (_) {});
    }
  }, {
    key: "set_node",
    value: function set_node(node) {
      this.node = node;
    }
  }]);

  return WobserverApiFallback;
}();

exports.WobserverApiFallback = WobserverApiFallback;

},{}],10:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WobserverClient = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _wobserver_api_fallback = require('./wobserver_api_fallback');

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var WobserverClient = function () {
  function WobserverClient(host) {
    _classCallCheck(this, WobserverClient);

    this.host = host;
    this.socket = null;
    this.node = 'local';
    this.promises = {};
  }

  _createClass(WobserverClient, [{
    key: 'connect',
    value: function connect(node_change, fallback_callback) {
      var _this = this;

      this.node_change = node_change;

      this.socket = new WebSocket('ws://' + this.host + '/ws');

      this.socket.onerror = function (error) {
        if (_this.socket.readyState == 3) {
          console.log('Socket can not connect, falling back to json api.');
          fallback_callback(new _wobserver_api_fallback.WobserverApiFallback(_this.host, _this.node));
        }
      };

      this.socket.onopen = function () {
        _this.command('hello');
        setInterval(function (_) {
          return _this.command('ping');
        });
      };

      this.socket.onmessage = function (msg) {
        var data = JSON.parse(msg.data);

        if (data.type == 'ehlo') {
          _this.node = data.data.name;
          _this.node_change(_this.node);
        } else if (data.type == 'setup_proxy' && data.data.node) {
          _this.node = data.data.node;
          _this.node_change(_this.node);
        } else {
          if (_this.promises[data.type]) {
            var promise = _this.promises[data.type].pop();
            if (promise) {
              promise(data);
            }
          }
        }
      };
    }
  }, {
    key: 'command',
    value: function command(_command) {
      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      var payload = JSON.stringify({
        command: _command,
        data: data
      });

      this.socket.send(payload);
    }
  }, {
    key: 'command_promise',
    value: function command_promise(command) {
      var _this2 = this;

      var data = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : null;

      return new Promise(function (resolve) {
        if (_this2.promises[command]) {
          _this2.promises[command].push(resolve);
        } else {
          _this2.promises[command] = [resolve];
        }

        _this2.command(command, data);
      });
    }
  }, {
    key: 'set_node',
    value: function set_node(node) {
      if (this.node != node) {
        this.command('setup_proxy', node);
      }
    }
  }]);

  return WobserverClient;
}();

exports.WobserverClient = WobserverClient;

},{"./wobserver_api_fallback":9}],11:[function(require,module,exports){
'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.WobserverRender = undefined;

var _popup = require('./interface/popup.js');

var _node_dialog = require('./interface/node_dialog.js');

var _process_detail = require('./interface/process_detail.js');

var _table_detail = require('./interface/table_detail.js');

var _application_graph = require('./interface/application_graph');

var _chart = require('./interface/chart');

// Helpers
function time_formatter(time) {
  var seconds = Math.floor(time / 1000);

  var days = Math.floor(seconds / 86400);seconds -= days * 86400;
  var hours = Math.floor(seconds / 3600);seconds -= hours * 3600;
  var minutes = Math.floor(seconds / 60);seconds -= minutes * 60;

  if (hours < 10) {
    hours = '0' + hours;
  }
  if (minutes < 10) {
    minutes = '0' + minutes;
  }
  if (seconds < 10) {
    seconds = '0' + seconds;
  }

  if (days > 0) {
    return days + 'days, ' + hours + ':' + minutes + ':' + seconds;
  }

  return hours + ':' + minutes + ':' + seconds;
}
function byte_formatter(usage) {
  var unit = ['B', 'kB', 'MB', 'GB'];
  var unit_counter = 0;

  while (unit_counter < unit.length && usage / 1024 > 8) {
    usage /= 1024;
    unit_counter++;
  }

  return Math.round(usage) + ' ' + unit[unit_counter];
}

function memory_formatter(memory) {
  return Object.keys(memory).reduce(function (formatted_memory, type) {
    formatted_memory[type] = byte_formatter(memory[type]);
    return formatted_memory;
  }, {});
}

function select_menu(nav, menu_item, item) {
  nav.childNodes.forEach(function (child) {
    return child.className = '';
  });
  menu_item.className = 'selected';

  if (nav.lastItem && nav.lastItem.on_close) {
    nav.lastItem.on_close();
  }

  item.on_open();

  nav.lastItem = item;
  if (history.pushState) {
    history.pushState(null, null, '#' + item.title.replace(' ', ''));
  } else {
    location.hash = '#' + item.title.replace(' ', '');
  }
}

function create_menu(wobserver) {
  var additional = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];

  var items = [{
    title: 'System',
    on_open: function on_open() {
      return wobserver.open('system', 1, WobserverRender.display_system);
    },
    on_close: function on_close() {
      return wobserver.close('system', 1);
    }
  }, {
    title: 'Load Charts',
    on_open: function on_open() {
      return wobserver.open('system', 0.25, WobserverRender.display_load_charts);
    },
    on_close: function on_close() {
      return wobserver.close('system', 0.25);
    }
  }, {
    title: 'Memory Allocators',
    on_open: function on_open() {
      return wobserver.open('allocators', 0.25, WobserverRender.display_allocators);
    },
    on_close: function on_close() {
      return wobserver.close('allocators', 0.25);
    }
  }, {
    title: 'Applications',
    on_open: function on_open() {
      return wobserver.open('application', 0, function (e) {
        return WobserverRender.display_applications(e, wobserver);
      });
    }
  }, {
    title: 'Processes',
    on_open: function on_open() {
      return wobserver.open('process', 4, WobserverRender.display_processes);
    },
    on_close: function on_close() {
      return wobserver.close('process', 4);
    }
  }, {
    title: 'Ports',
    on_open: function on_open() {
      return wobserver.open('ports', 8, WobserverRender.display_ports);
    },
    on_close: function on_close() {
      return wobserver.close('ports', 8);
    }
  }, {
    title: 'Table Viewer',
    on_open: function on_open() {
      return wobserver.open('table', 0, WobserverRender.display_table);
    },
    on_close: function on_close() {
      return wobserver.close('table', 0);
    }
  }];

  items = items.concat(additional);

  items.push({
    title: 'About',
    on_open: function on_open() {
      return wobserver.open('about', 0, WobserverRender.display_about);
    }
  });

  var menu = document.getElementById('menu');
  var nav = document.createElement('nav');

  while (menu.hasChildNodes()) {
    menu.removeChild(menu.lastChild);
  }

  nav.lastItem = null;

  var first = false;

  items.map(function (item) {
    var menu_item = document.createElement('a');
    var menu_text = document.createTextNode(item.title);

    //menu_item.setAttribute('href', '#');
    menu_item.appendChild(menu_text);
    menu_item.addEventListener('click', function () {
      select_menu(nav, menu_item, item);
    });

    nav.appendChild(menu_item);

    item.menu_item = menu_item;

    return item;
  });

  menu.appendChild(nav);

  setTimeout(function () {
    var select = items.find(function (item) {
      return '#' + item.title.replace(' ', '') == window.location.hash;
    });

    if (!select) {
      select = items[0];
    }

    select_menu(nav, select.menu_item, select);
  }, 100);
}

function create_footer(wobserver) {
  var footer = document.getElementById('footer');

  var switch_button = document.createElement('span');
  switch_button.className = 'button';
  switch_button.style.marginRight = "1em";
  switch_button.innerHTML = 'Switch Node';

  var node_selection = new _node_dialog.NodeDialog(wobserver);

  switch_button.addEventListener('click', function () {
    return node_selection.show();
  });

  footer.appendChild(switch_button);

  var node = document.createElement('span');

  node.innerHTML = 'Connected to: <em id="connected_node">local</em>.';

  footer.appendChild(node);
}

function show_application_graph(app_name, description, wobserver) {
  wobserver.client.command_promise('application/' + app_name).then(function (e) {
    var application = e.data;

    if (app_name != description) {
      document.getElementById('application_app_description').innerHTML = description;
    } else {
      document.getElementById('application_app_description').innerHTML = '';
    }

    _application_graph.ApplicationGraph.show(application, 'application_chart');

    document.querySelectorAll('.process-node').forEach(function (node) {
      var node_name = node.getElementsByClassName('node-name')[0].innerText;
      node.addEventListener('click', function (_) {
        new _process_detail.ProcessDetail(node_name, wobserver).show();
      });
    });
  });
}

var WobserverRender = {
  init: function init(wobserver) {
    window.onload = function () {
      var wobserver_root = document.getElementById('wobserver');

      wobserver_root.innerHTML = '<div id="menu"></div>\n        <div id="content"></div>\n        <div id="footer"></div>';

      create_footer(wobserver);

      wobserver.client.command_promise('custom').then(function (e) {
        create_menu(wobserver, e.data.filter(function (custom) {
          return !e.api_only;
        }).map(function (custom) {
          return {
            title: custom.title,
            on_open: function on_open() {
              return wobserver.open(custom.command, custom.refresh, WobserverRender.show_custom);
            },
            on_close: function on_close() {
              return wobserver.close(custom.command, custom.refresh);
            }
          };
        }));
      }).catch(function (_) {
        return create_menu(wobserver);
      });
    };
  },
  set_node: function set_node(node) {
    var label = document.getElementById('connected_node');

    if (label) {
      label.innerHTML = node;
    } else {
      setTimeout(function () {
        return WobserverRender.set_node(node);
      }, 100);
    }
  },
  display_system: function display_system(e) {
    var system = e.data;
    var content = document.getElementById('content');

    var architecture = '<table class="inline">\n        <caption>System and Architecture</caption>\n        <tr><th>System Version</th><td>' + system.architecture.elixir_version + '</td></tr>\n        <tr><th>Erlang/OTP Version</th><td>' + system.architecture.otp_release + '</td></tr>\n        <tr><th>ERTS Version</th><td>' + system.architecture.erts_version + '</td></tr>\n        <tr><th>Compiled for</th><td>' + system.architecture.system_architecture + '</td></tr>\n        <tr><th>Emulated Wordsize</th><td>' + system.architecture.wordsize_external + '</td></tr>\n        <tr><th>Process Wordsize</th><td>' + system.architecture.wordsize_internal + '</td></tr>\n        <tr><th>SMP Support</th><td>' + system.architecture.smp_support + '</td></tr>\n        <tr><th>Thread Support</th><td>' + system.architecture.threads + '</td></tr>\n        <tr><th>Async thread pool size</th><td>' + system.architecture.thread_pool_size + '</td></tr>\n      </table>';

    //let scheduler_average = (100*system.scheduler.reduce((sum, e) => sum + e, 0) / (system.scheduler.length || 1));
    //let scheduler_average = system.scheduler.map(e=>Math.floor(e*100)+'%').join(',');
    var scheduler_average = system.scheduler.map(function (e) {
      return '<span class="load">' + Math.floor(e * 100) + '</span>%';
    }).join(' ');

    var cpu = '<table class="inline">\n        <caption>CPU\'s and Threads</caption>\n        <tr><th>Logical CPU\'s</th><td>' + system.cpu.logical_processors + '</td></tr>\n        <tr><th>Online Logical CPU\'s</th><td>' + system.cpu.logical_processors_online + '</td></tr>\n        <tr><th>Available Logical CPU\'s</th><td>' + system.cpu.logical_processors_available + '</td></tr>\n        <tr><th>Schedulers</th><td>' + system.cpu.schedulers + '</td></tr>\n        <tr><th>Online schedulers</th><td>' + system.cpu.schedulers_online + '</td></tr>\n        <tr><th>Available schedulers</th><td>' + system.cpu.schedulers_available + '</td></tr>\n        <tr><th>Average sch. Load</th><td>' + scheduler_average + '</td></tr>\n      </table>';

    var memory_formatted = memory_formatter(system.memory);

    var memory = '<table class="inline">\n        <caption>Memory Usage</caption>\n        <tr><th>Total</th><td>' + memory_formatted.total + '</td></tr>\n        <tr><th>Processes</th><td>' + memory_formatted.process + '</td></tr>\n        <tr><th>Atoms</th><td>' + memory_formatted.atom + '</td></tr>\n        <tr><th>Binaries</th><td>' + memory_formatted.binary + '</td></tr>\n        <tr><th>Code</th><td>' + memory_formatted.code + '</td></tr>\n        <tr><th>ETS</th><td>' + memory_formatted.ets + '</td></tr>\n      </table>';

    var statistics = '<table class="inline">\n        <caption>Statistics</caption>\n        <tr><th>Up time</th><td>' + time_formatter(system.statistics.uptime) + '</td></tr>\n        <tr><th>Max Processes</th><td>' + system.statistics.process_max + '</td></tr>\n        <tr><th>Processes</th><td>' + system.statistics.process_total + '</td></tr>\n        <tr><th>Run Queue</th><td>' + system.statistics.process_running + '</td></tr>\n        <tr><th>IO Input</th><td>' + byte_formatter(system.statistics.input) + '</td></tr>\n        <tr><th>IO Output</th><td>' + byte_formatter(system.statistics.output) + '</td></tr>\n      </table>';

    content.innerHTML = architecture + cpu + memory + statistics;
  },
  display_applications: function display_applications(e, wobserver) {
    var applications = e.data;
    applications.sort(function (a, b) {
      return a.name.localeCompare(b.name);
    });
    var content = document.getElementById('content');

    var app_list = '<div id="applications_header">\n      <label for="applications_app_list">Application:</label>\n      <select id="applications_app_list"></select>\n      <p id="application_app_description"></p>\n    </div>';

    var app_tree = '<div class="chart" id="application_chart"></div>';

    content.innerHTML = app_list + app_tree;

    var list = document.getElementById('applications_app_list');
    var application_descriptions = {};

    applications.forEach(function (app) {
      var li = document.createElement('option');

      li.value = app.name;
      li.innerHTML = app.name + ' (' + app.version + ')';
      application_descriptions[app.name] = app.description;

      list.appendChild(li);
    });

    list.addEventListener('change', function (element) {
      show_application_graph(list.value, application_descriptions[list.value], wobserver);
    });

    show_application_graph(applications[0].name, applications[0].description, wobserver);
  },
  display_processes: function display_processes(e) {
    var processes = e.data;
    var content = document.getElementById('content');
    var table = content.querySelector('table');
    var sorted = -1;
    var reverse = false;

    if (table) {
      table.querySelectorAll('th').forEach(function (e, i) {
        if (e.className.includes('sorttable_sorted_reverse')) {
          sorted = i;
          reverse = true;
        } else if (e.className.includes('sorttable_sorted')) {
          sorted = i;
        }
      });
    }

    var formatted_processes = processes.map(function (process) {
      return '<tr>\n        <td><a href="javascript:window.show_process(\'' + process.pid + '\')">' + process.pid + '</a></td>\n        <td>' + process.init + '</td>\n        <td>' + process.reductions + '</td>\n        <td>' + process.memory + '</td>\n        <td>' + process.message_queue_length + '</td>\n        <td>' + process.current + '</td>\n      </tr>';
    }).join('');

    content.innerHTML = '\n      <table class="process_table" style="text-align: left;">\n        <thead><tr>\n          <th>Pid</th>\n          <th>Name or Initial Function</th>\n          <th>Reds</th>\n          <th>Memory</th>\n          <th>MsgQ</th>\n          <th>Current Function</th>\n        </tr></thead>\n        ' + formatted_processes + '\n      </table>\n    ';

    table = content.querySelector('table');
    sorttable.makeSortable(table);

    if (sorted >= 0) {
      var th = table.getElementsByTagName('th')[sorted];
      sorttable.innerSortFunction.apply(th, []);
      if (reverse) {
        sorttable.innerSortFunction.apply(th, []);
      }
    }
  },
  display_ports: function display_ports(e) {
    var data = e.data;
    var content = document.getElementById('content');
    var table = content.querySelector('table');
    var sorted = -1;
    var reverse = false;

    if (table) {
      table.querySelectorAll('th').forEach(function (e, i) {
        if (e.className.includes('sorttable_sorted_reverse')) {
          sorted = i;
          reverse = true;
        } else if (e.className.includes('sorttable_sorted')) {
          sorted = i;
        }
      });
    }

    var formatted_ports = data.map(function (port) {
      var links = port.links.map(function (link) {
        return '<a href="javascript:window.show_process(\'' + link + '\')">' + link + '</a>';
      }).join('');
      return '<tr>\n        <td>' + port.id + '</td>\n        <td>' + port.name + '</td>\n        <td><a href="javascript:window.show_process(\'' + port.connected + '\')">' + port.connected + '</a></td>\n        <td>' + port.input + '</td>\n        <td>' + port.output + '</td>\n        <td>' + links + '</td>\n      </tr>';
    }).join('');

    content.innerHTML = '\n      <table class="process_table" style="text-align: left;">\n        <thead><tr>\n          <th>ID</th>\n          <th>Name</th>\n          <th>Owner</th>\n          <th>Input</th>\n          <th>Output</th>\n          <th>Links</th>\n        </tr></thead>\n        ' + formatted_ports + '\n      </table>\n    ';

    table = content.querySelector('table');
    sorttable.makeSortable(table);

    if (sorted >= 0) {
      var th = table.getElementsByTagName('th')[sorted];
      sorttable.innerSortFunction.apply(th, []);
      if (reverse) {
        sorttable.innerSortFunction.apply(th, []);
      }
    }
  },
  display_load_charts: function display_load_charts(e) {
    var system = e.data;
    var content = document.getElementById('content');
    var scheduler_chart = null;
    var mem_chart = null;
    var io_chart = null;

    if (document.getElementById('memory_chart')) {
      scheduler_chart = document.getElementById('scheduler_chart').chart;
      mem_chart = document.getElementById('memory_chart').chart;
      io_chart = document.getElementById('io_chart').chart;
    } else {
      (function () {
        content.innerHTML = '<div id="scheduler_chart" style="width:100%;"></div><div id="memory_chart"></div><div id="io_chart"></div>';

        var r_set = [1, 0, 0, 1, 0, 1, 1, 0];
        var g_set = [0, 1, 0, 1, 1, 0, 1, 0];
        var b_set = [0, 0, 1, 0, 1, 1, 1, 0];
        var schedulers_setup = system.scheduler.map(function (_, i) {
          return {
            label: 'S' + (i + 1),
            r: r_set[i % 8] == 1 ? 255 : 0,
            g: g_set[i % 8] == 1 ? 255 : 0,
            b: b_set[i % 8] == 1 ? 255 : 0
          };
        });

        scheduler_chart = new _chart.WobserverChart('scheduler_chart', schedulers_setup, '%');

        mem_chart = new _chart.WobserverChart('memory_chart', [{
          label: 'Total',
          r: 255,
          g: 0,
          b: 0
        }, {
          label: 'Process',
          r: 0,
          g: 255,
          b: 0
        }, {
          label: 'Atom',
          r: 0,
          g: 0,
          b: 255
        }, {
          label: 'Binary',
          r: 255,
          g: 255,
          b: 0
        }, {
          label: 'Code',
          r: 0,
          g: 255,
          b: 255
        }, {
          label: 'Ets',
          r: 255,
          g: 0,
          b: 255
        }], 'MB');

        io_chart = new _chart.WobserverChart('io_chart', [{
          label: 'Input',
          r: 255,
          g: 0,
          b: 0
        }, {
          label: 'Output',
          r: 0,
          g: 255,
          b: 0
        }], 'MB');
      })();
    }

    var data = system.scheduler.map(function (v) {
      return Math.floor(10000 * v) / 100;
    });
    data.timestamp = e.timestamp;

    scheduler_chart.update(data);

    data = [system.memory.total, system.memory.process, system.memory.atom, system.memory.binary, system.memory.code, system.memory.ets].map(function (v) {
      return Math.floor(v / 1048576);
    });
    data.timestamp = e.timestamp;

    mem_chart.update(data);

    data = [system.statistics.input, system.statistics.output].map(function (v) {
      return Math.floor(v / 1048576);
    });
    data.timestamp = e.timestamp;

    io_chart.update(data);
  },
  display_allocators: function display_allocators(e) {
    var allocators = e.data;
    var content = document.getElementById('content');

    var size_chart = null;
    var util_chart = null;

    allocators.unshift(allocators.reduce(function (a, v) {
      a.carrier += v.carrier;
      a.block += v.block;

      return a;
    }, { type: 'Total', carrier: 0, block: 0 }));

    if (document.getElementById('size_chart')) {
      size_chart = document.getElementById('size_chart').chart;
      util_chart = document.getElementById('util_chart').chart;
    } else {
      (function () {
        content.innerHTML = '<div id="size_chart" style="width:100%;height: 30%;"></div><div id="util_chart" style="width:100%;height: 30%;"></div><div id="alloc_table"></div>';

        var r_set = [1, 0, 0, 1, 0, 1, 1, 0];
        var g_set = [0, 1, 0, 1, 1, 0, 1, 0];
        var b_set = [0, 0, 1, 0, 1, 1, 1, 0];
        var schedulers_setup = allocators.map(function (data, i) {
          return {
            label: data.type,
            r: r_set[i % 8] == 1 ? 255 : 0,
            g: g_set[i % 8] == 1 ? 255 : 0,
            b: b_set[i % 8] == 1 ? 255 : 0
          };
        });

        size_chart = new _chart.WobserverChart('size_chart', schedulers_setup, '%');
        util_chart = new _chart.WobserverChart('util_chart', schedulers_setup, 'MB');
      })();
    }

    var data = allocators.map(function (v) {
      return Math.floor(v.block * 100 / v.carrier);
    });
    data.timestamp = e.timestamp;

    size_chart.update(data);

    data = allocators.map(function (v) {
      return Math.floor(v.carrier / 1048576);
    });
    data.timestamp = e.timestamp;
    util_chart.update(data);

    var alloc_table = document.getElementById('alloc_table');

    var alloc_rows = allocators.map(function (v) {
      return '<tr><td>' + v.type + '</td><td>' + byte_formatter(v.block) + '</td><td>' + byte_formatter(v.carrier) + '</td></tr>';
    }).join('');
    alloc_table.innerHTML = '\n      <table class="process_table" style="text-align: left;">\n        <thead><tr>\n          <th>Type</th>\n          <th>Block Size</th>\n          <th>Carrier Size</th>\n        </tr></thead>\n        ' + alloc_rows + '\n      </table>\n    ';
  },
  display_table: function display_table(e) {
    var data = e.data;
    var content = document.getElementById('content');
    var table = content.querySelector('table');
    var sorted = -1;
    var reverse = false;

    if (table) {
      table.querySelectorAll('th').forEach(function (e, i) {
        if (e.className.includes('sorttable_sorted_reverse')) {
          sorted = i;
          reverse = true;
        } else if (e.className.includes('sorttable_sorted')) {
          sorted = i;
        }
      });
    }

    var formatted_tables = data.map(function (t) {
      var id = !isNaN(parseFloat(t.id)) && isFinite(t.id) ? t.id : '';
      return '<tr>\n        <td><a href="javascript:window.show_table(\'' + t.id + '\')">' + t.name + '</a></td>\n        <td>' + id + '</td>\n        <td>' + t.size + '</td>\n        <td>' + byte_formatter(t.memory) + '</td>\n        <td>' + t.protection + '</td>\n        <td><a href="javascript:window.show_process(\'' + t.owner + '\')">' + t.owner + '</a></td>\n      </tr>';
    }).join('');

    content.innerHTML = '\n      <table class="process_table" style="text-align: left;">\n        <thead><tr>\n          <th>Name</th>\n          <th>ID</th>\n          <th>Objects</th>\n          <th>Size</th>\n          <th>Protection</th>\n          <th>Owner</th>\n        </tr></thead>\n        ' + formatted_tables + '\n      </table>\n    ';

    table = content.querySelector('table');
    sorttable.makeSortable(table);

    if (sorted >= 0) {
      var th = table.getElementsByTagName('th')[sorted];
      sorttable.innerSortFunction.apply(th, []);
      if (reverse) {
        sorttable.innerSortFunction.apply(th, []);
      }
    }
  },
  display_about: function display_about(e) {
    var about = e.data;
    var content = document.getElementById('content');

    var urls = about.links.map(function (url) {
      return '<tr><th>' + url.name + '</th><td><a href="' + url.url + '">' + url.url + '</a></td></tr>';
    }).join('');

    content.innerHTML = '\n      <h1 style="margin-bottom:0;">' + about.name + '</h1>\n      <span style="font-weight:bold;font-size:80%;font-style:italic;">Version: ' + about.version + '</span>\n      <p>' + about.description + '</p>\n      <h2>Info</h2>\n      <table style="text-align: left;">\n        <tr><th>Licence</th><td><a href="' + about.license.url + '">' + about.license.name + '</a></td></tr>\n        ' + urls + '\n      </table>\n    ';
  },
  show_process: function show_process(process, wobserver) {
    new _process_detail.ProcessDetail(process, wobserver).show();
  },
  show_table: function show_table(table, wobserver) {
    new _table_detail.TableDetail(table, wobserver).show();
  },
  show_custom: function show_custom(e) {
    var content = document.getElementById('content');

    // content.innerHTML = show_custom_data(e.data);
    content.innerHTML = show_custom_data([{
      x: 5,
      y: 6
    }, {
      x: 5,
      y: 6
    }]);
  }
};

function show_custom_data(data) {
  var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  if (data instanceof Array) {
    return show_custom_array_table(data, name);
  } else {
    return show_custom_table(data, name);
  }
}

function show_custom_array_table(data) {
  var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  var header = Object.keys(data[0]).map(function (key) {
    return '<th>' + key + '</th>';
  }).join('');

  var rows = data.map(function (row) {
    return Object.keys(row).map(function (key) {
      return '<td>' + row[key] + '</td>';
    }).join('');
  }).map(function (row) {
    return '<tr>' + row + '</tr>';
  }).join('');

  return '\n    <table class="generic_array_table">\n      <caption>' + name + '</caption>\n      <thead>\n        <tr>' + header + '</tr>\n      </thead>\n      ' + rows + '\n    </table>\n  ';
}

function show_custom_table(data) {
  var name = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : '';

  var raw_table = !Object.keys(data).map(function (key) {
    return data[key] instanceof Object;
  }).reduce(function (a, b) {
    return a || b;
  });

  if (raw_table) {
    var rows = Object.keys(data).map(function (key) {
      return '<tr><th>' + key + '</th><td>' + data[key] + '</td></tr>';
    }).join('');

    return '\n      <table class="inline">\n        <caption>' + name + '</caption>\n        ' + rows + '\n      </table>\n    ';
  } else {
    var tables = Object.keys(data).map(function (key) {
      return show_custom_data(data[key], key);
    }).join('');

    return '\n      <div>\n        <span>' + name + '</span>\n        ' + tables + '\n      </div>\n    ';
  }
}

exports.WobserverRender = WobserverRender;

},{"./interface/application_graph":2,"./interface/chart":3,"./interface/node_dialog.js":4,"./interface/popup.js":5,"./interface/process_detail.js":6,"./interface/table_detail.js":7}]},{},[1])

//# sourceMappingURL=app.js.map
